/*
 https://www.electronicwings.com/
  SD Card Interface code for ESP32
  SPI Pins of ESP32 SD card as follows:
  CS    = 5;
  MOSI  = 23;
  MISO  = 19;
  SCK   = 18; 
*/

#include <SPI.h>
#include <SD.h>

#define MISO 15
#define MOSI 16
#define SCK 17
//#define CS 18

File myFile;
const int CS = 18;

unsigned char frameTest[115200];
//String stringaAppoggio;

void WriteFile(const char* path, const char* message) {
  // open the file. note that only one file can be open at a time,
  // so you have to close this one before opening another.
  myFile = SD.open(path, FILE_WRITE);
  // if the file opened okay, write to it:
  if (myFile) {
    Serial.printf("Writing to %s ", path);
    myFile.println(message);
    myFile.close();  // close the file:
    Serial.println("completed.");
  }
  // if the file didn't open, print an error:
  else {
    Serial.println("error opening file ");
    Serial.println(path);
  }
}

char ex[5];  //= "0x71,";
int numChar;
char i = -1;

void ReadFile(const char* path) {
  // open the file for reading:
  myFile = SD.open(path);
  if (myFile) {
    Serial.printf("Reading file from %s\n", path);
    // read from the file until there's nothing else in it:
    while (myFile.available()) {
      i++;
      ex[i] = myFile.read();
      if (i == 4) {
        ex[4] = '\0';
        // Conversione da stringa esadecimale a intero
        char* endptr;                          // Puntatore per indicare la fine della parte convertita
        int pixel = (int)strtol(ex, &endptr, 16);  // Base 16 per esadecimale
        frameTest[numChar]=pixel;
        Serial.println(numChar);
        numChar++;
        i = -1;
      }
    }
    Serial.write("\n finito :D");
    myFile.close();  // close the file:
  } else {
    // if the file didn't open, print an error:
    //Serial.println("error opening test.txt");
    Serial.printf("error opening %s\n", path);
    
  }
}


void setup() {
  SPI.begin(SCK, MISO, MOSI, CS);
  Serial.begin(115200);  // Set serial baud rate to 9600
  delay(500);
#if 1
  while (!Serial) { ; }  // wait for serial port to connect. Needed for native USB port only
  Serial.println("Initializing SD card...");
  if (!SD.begin(CS)) {
    Serial.println("initialization failed!");
    return;
  }
#endif
  Serial.println("initialization done.");

  //WriteFile("/test.txt", "ElectronicWings.com");
  if(int max = -1;max<numChar){
    max = numChar;
    ReadFile("/image.txt");  // /image.txt /test.txt
  }
  //ReadFile("/image.txt");  // /image.txt /test.txt

  //const unsigned char NC0[115200]
}

void loop() {
  // nothing happens after setup
}
